import { Browser, BrowserContext, Page } from 'puppeteer';
import { CreateOptions } from '../model/interface';
/**
 * Function to create a new tab in the browser instance
 * @param Browser - Browser instance to create a new tab
 * @returns - Returns a new tab or false if it fails
 */
export declare function initBrowser(Browser: Browser): Promise<Page | boolean>;
/**
 * Function to create a new session in the browser instance
 * @param options - Options to create a new session in the browser instance
 */
export declare function PathSession(options: CreateOptions): void;
/**
 * Function to create a new session in the browser instance
 * @param options - Options to create a new session in the browser instance
 * @param ev - Event to emit status
 * @returns - Returns a new browser instance or false if it fails
 */
export declare function initLaunch(options: CreateOptions, ev: any): Promise<Browser | boolean>;
/**
 * Function to create a new tab in the browser instance
 * @param Browser - Browser instance to create a new tab
 * @returns - Returns a new tab or false if it fails
 */
export declare function oneTab(Browser: Browser | BrowserContext): Promise<Page | any>;
export declare function getPathChrome(): string | undefined;
