import { OnMode } from '../../model/enum';
import { StatusFind, InterfaceQrcode } from '../../model/interface';
/**
 * Attribution and behavior change of a given event
 */
export declare class CallbackOnStatus {
    private listenerEmitter;
    /**
     * Emit an event with the specified type and arguments
     * @param args Event arguments, including onType to specify the event type
     */
    emitStatusFind(args: InterfaceQrcode | StatusFind | any): void;
    /**
     * Listen for specific user events
     * @param type Type of event to monitor
     * @param callback Function to call with event data
     */
    on(type: OnMode, callback: (state: StatusFind | InterfaceQrcode | any) => void): void;
}
