"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallbackOnStatus = void 0;
const events_1 = require("events");
/**
 * Attribution and behavior change of a given event
 */
class CallbackOnStatus {
    constructor() {
        this.listenerEmitter = new events_1.EventEmitter();
    }
    /**
     * Emit an event with the specified type and arguments
     * @param args Event arguments, including onType to specify the event type
     */
    emitStatusFind(args) {
        if (!args.onType) {
            throw new Error('onType is required to emit an event');
        }
        this.listenerEmitter.emit(args.onType, args);
    }
    /**
     * Listen for specific user events
     * @param type Type of event to monitor
     * @param callback Function to call with event data
     */
    on(type, callback) {
        this.listenerEmitter.on(type, callback);
    }
}
exports.CallbackOnStatus = CallbackOnStatus;
//# sourceMappingURL=callback-on.layes.js.map