import { ListenerLayer } from './listener.layes';
import { Page, Browser } from 'puppeteer';
import { CreateOptions, InterfaceScope } from '../../model/interface';
export declare class GroupLayer extends ListenerLayer {
    page: Page;
    browser: Browser;
    options: CreateOptions;
    ev: any;
    constructor(page: Page, browser: Browser, options: CreateOptions, ev: any);
    /**
     * Creates a new chat group
     * @param {string} groupName Group name
     * @param {(string | string[])} contacts Participants id '000000000000@c.us'
     */
    createGroup(groupName: string, contacts: string | string[]): Promise<InterfaceScope>;
    /**
     * Adds participant to Group
     * @param {string} groupId Chat id ('0000000000-00000000@g.us' or '000000000000000000@g.us')
     * @param {(string | string[])} contacts Participants id '000000000000@c.us'
     */
    addParticipant(groupId: string, contacts: string | string[]): Promise<InterfaceScope>;
    /**
     * Parameters to change group description
     * @param {string} groupId group number
     * @param {string} description group description
     */
    setGroupDescription(groupId: string, description: string): Promise<InterfaceScope>;
    /**
     * Parameters to change group image
     * @param {string} groupId group number
     * @param {string} path of image
     */
    setGroupImage(groupId: string, path: string): Promise<InterfaceScope>;
}
