import { Page, Browser } from 'puppeteer';
import { CreateOptions } from '../../model/interface/';
export declare class OnMod {
    page: Page;
    browser: Browser;
    options: CreateOptions;
    ev: any;
    constructor(page: Page, browser: Browser, options: CreateOptions, ev: any);
    /**
     * Execute a page evaluation with error handling.
     */
    private safeEvaluate;
    /**
     * Listen to interface changes.
     */
    interfaceChange(): void;
    /**
     * Listen to deleted messages.
     */
    newDeleteMessage(): void;
    /**
     * Listen to edited messages.
     */
    newEditMessage(): void;
    /**
     * Listen to new messages.
     */
    newMessage(): void;
    /**
     * Listen to reaction messages.
     */
    onReactionMessage(): void;
    /**
     * Listen to introductory reactions.
     */
    onIntroReactionMessage(): void;
    /**
     * Listen to message acknowledgment (read receipt).
     */
    newOnAck(): void;
}
