import { GroupLayer } from './group.layer';
import { Page, Browser } from 'puppeteer';
import { CreateOptions, InterfaceHost, Contact } from '../../model/interface';
export declare class RetrieverLayer extends GroupLayer {
    page: Page;
    browser: Browser;
    options: CreateOptions;
    ev: any;
    constructor(page: Page, browser: Browser, options: CreateOptions, ev: any);
    /**
     * returns a list of contacts
     * @returns contacts
     */
    getAllContacts(): Promise<Contact>;
    /**
     * Get information from the connected number
     * @returns Current host device details
     */
    getHost(): Promise<InterfaceHost>;
    /**
     * Get screenshot
     * @returns base64 image
     */
    screenshot(): Promise<{
        base64Image: string;
    }>;
    /**
     * Check if the number exists
     * @param {string} number phone number
     */
    checkNumber(number: string): Promise<any>;
    /**
     * Get version of the current whatsapp
     */
    getWAVersion(): Promise<string>;
}
