"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RetrieverLayer = void 0;
const group_layer_1 = require("./group.layer");
class RetrieverLayer extends group_layer_1.GroupLayer {
    constructor(page, browser, options, ev) {
        super(page, browser, options, ev);
        this.page = page;
        this.browser = browser;
        this.options = options;
        this.ev = ev;
    }
    /**
     * returns a list of contacts
     * @returns contacts
     */
    async getAllContacts() {
        return await this.page.evaluate(() => API.getAllContacts());
    }
    /**
     * Get information from the connected number
     * @returns Current host device details
     */
    async getHost() {
        return await this.page.evaluate(() => API.getHost());
    }
    /**
     * Get screenshot
     * @returns base64 image
     */
    async screenshot() {
        const base64 = await this.page
            .screenshot({
            encoding: 'base64',
        })
            .catch(() => undefined);
        return { base64Image: `data:image/png;base64,${base64}` };
    }
    /**
     * Check if the number exists
     * @param {string} number phone number
     */
    async checkNumber(number) {
        return await this.page.evaluate((number) => API.checkNumberStatus(number), number);
    }
    /**
     * Get version of the current whatsapp
     */
    async getWAVersion() {
        return await this.page.evaluate(() => API.getWAVersion());
    }
}
exports.RetrieverLayer = RetrieverLayer;
//# sourceMappingURL=retriever.layer.js.map