import { Page, Browser } from 'puppeteer';
import { SendOptions } from '../../model/interface';
import { RetrieverLayer } from './retriever.layer';
import { CreateOptions } from '../../model/interface';
export declare class SenderLayer extends RetrieverLayer {
    page: Page;
    browser: Browser;
    options: CreateOptions;
    ev: any;
    constructor(page: Page, browser: Browser, options: CreateOptions, ev: any);
    /**
     * Sends image message
     * @param to Chat id
     * @param filePath File path or http link
     */
    sendImage(to: string, filePath: string, options?: any): Promise<unknown>;
    /**
     * Sends image message base64
     * @param to Chat id
     * @param base64 File path, http link or base64Encoded
     */
    sendImageFromBase64(to: string, base64: string, options?: any): Promise<unknown>;
    /**
     * Sends file from path
     * @param to Chat id
     * @param filePath File path
     */
    sendFile(to: string, filePath: string, options?: any): Promise<unknown>;
    /**
     * Sends a text message to given chat
     * @param to chat id: xxxxx@us.c
     * @param body text message
     */
    sendText(to: string, body: string, options?: any): Promise<unknown>;
    /**
     * Send audio base64
     * @param to Chat id
     * @param base64 base64 data
     */
    sendAudioBase64(to: string, base64: string, options?: any): Promise<unknown>;
    /**
     * Send audio file
     * @param to Chat id
     * @param filePath Path file
     */
    sendAudio(to: string, filePath: string, options?: any): Promise<unknown>;
    sendMessage(options: SendOptions): Promise<any>;
}
