"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebPack = void 0;
const layes_1 = require("../api/layes");
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
class WebPack extends layes_1.SenderLayer {
    constructor(page, browser, options, ev) {
        super(page, browser, options, ev);
        this.page = page;
        this.browser = browser;
        this.options = options;
        this.ev = ev;
        this.loadPageStatus = false;
        this.initService();
        this.page.on('load', async () => {
            if (this.loadPageStatus) {
                await this.initService();
                this.loadPageStatus = false;
            }
        });
    }
    async initService() {
        try {
            const storeModuleExists = await this.page.evaluate(() => {
                const isStoreUndefined = typeof (window === null || window === void 0 ? void 0 : window.Store) === 'undefined';
                const isApiUndefined = typeof (window === null || window === void 0 ? void 0 : window.API) === 'undefined';
                const isStoreEmpty = (window === null || window === void 0 ? void 0 : window.Store) && !Object.keys(window === null || window === void 0 ? void 0 : window.Store).length;
                const isApiEmpty = (window === null || window === void 0 ? void 0 : window.API) && !Object.keys(window === null || window === void 0 ? void 0 : window.API).length;
                return isStoreUndefined || isApiUndefined || isStoreEmpty || isApiEmpty;
            });
            if (storeModuleExists) {
                await this.loadDebugModule();
                const apiScript = fs.readFileSync(require.resolve(path.join(__dirname, '../assets/', 'api.js')), 'utf8');
                await this.page.evaluate(apiScript);
                await this.checkStoreInitialization();
                this.loadPageStatus = true;
                this.initListener();
            }
        }
        catch (error) {
            console.error('Erro ao iniciar o serviço:', error);
        }
    }
    async loadDebugModule() {
        return this.page.evaluate(() => {
            return new Promise((resolve) => {
                const checkDebug = () => {
                    try {
                        return require('__debug');
                    }
                    catch (_a) {
                        return false;
                    }
                };
                const checkObjects = () => {
                    const debug = checkDebug();
                    if (debug && !window['__debug']) {
                        window['__debug'] = debug;
                        resolve(true);
                    }
                    else {
                        setTimeout(checkObjects, 200);
                    }
                };
                checkObjects();
            });
        });
    }
    async checkStoreInitialization() {
        return this.page.evaluate(() => {
            return new Promise((resolve) => {
                const checkStoreLoaded = () => {
                    try {
                        return Object.keys(window.Store).length > 0;
                    }
                    catch (_a) {
                        return false;
                    }
                };
                const checkObjects = () => {
                    var _a, _b;
                    if (checkStoreLoaded() &&
                        ((_a = window === null || window === void 0 ? void 0 : window.Store) === null || _a === void 0 ? void 0 : _a.Stream) &&
                        ((_b = window === null || window === void 0 ? void 0 : window.Store) === null || _b === void 0 ? void 0 : _b.Msg)) {
                        resolve(true);
                    }
                    else {
                        setTimeout(checkObjects, 200);
                    }
                };
                checkObjects();
            });
        });
    }
}
exports.WebPack = WebPack;
//# sourceMappingURL=webpack.js.map