"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initWs = void 0;
const interface_1 = require("./model/interface");
const app_1 = require("./app");
const services_ws_1 = require("./services/services-ws");
const interface_2 = require("../webpack/model/interface");
const check_up_to_date_1 = require("../webpack/api/check-up-to-date");
/**
 * Start the Web Service
 */
async function initWs(options) {
    const mergeOptions = Object.assign(Object.assign({}, interface_1.defaultConfigWs), options);
    const mergeWebPack = Object.assign(Object.assign({}, interface_2.defaultConfig), mergeOptions);
    if (!!(options === null || options === void 0 ? void 0 : options.puppeteerOptions)) {
        mergeWebPack.puppeteerOptions = Object.assign(Object.assign({}, interface_2.defaultConfig.puppeteerOptions), options.puppeteerOptions);
    }
    if (mergeWebPack.updatesLog) {
        await (0, check_up_to_date_1.checkUpdates)();
    }
    const app = (0, app_1.appExpress)(mergeWebPack);
    new services_ws_1.ServiceWs(app, mergeWebPack);
    app
        .listen(mergeWebPack.port, () => {
        console.log(`Web service on ${mergeWebPack.hostServer}:${mergeWebPack.port}`);
    })
        .on('error', (err) => {
        if (err.code === 'EADDRINUSE') {
            console.error(`Port ${mergeWebPack.port} is already in use.`);
        }
        else {
            console.error(`Server error: ${err.message}`);
        }
    });
    app.use(function (req, res) {
        res.send({
            text: 'Route does not exist!',
            status: '404',
            error: true,
        });
    });
}
exports.initWs = initWs;
//# sourceMappingURL=init-ws.js.map