"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const treatment_1 = __importDefault(require("../../../help/treatment"));
class InicializePutUser {
    async activateUserRouter(req, res) {
        const body = req.body;
        const checkADM = await treatment_1.default.CheckAdminLogin(req);
        if (checkADM.error === false) {
            if (!!body.id && body.id.length) {
                const change = await treatment_1.default.dbUser.activateUser(body.id);
                if (typeof change === 'boolean' && change === true) {
                    res.send({
                        error: false,
                        text: 'User successfully activated!',
                    });
                }
                else {
                    res.send({
                        error: true,
                        text: change,
                    });
                }
            }
            else {
                res.send({
                    error: true,
                    text: 'Object incorrect',
                });
            }
        }
        else {
            res.send(checkADM);
        }
    }
    async deactivateUserRouter(req, res) {
        const body = req.body;
        const checkADM = await treatment_1.default.CheckAdminLogin(req);
        if (checkADM.error === false) {
            if (!!body.id && body.id.length) {
                const change = await treatment_1.default.dbUser.deactivateUser(body.id);
                if (typeof change === 'boolean' && change === true) {
                    res.send({
                        error: false,
                        text: 'User deactivated successfully!',
                    });
                }
                else {
                    res.send({
                        error: true,
                        text: change,
                    });
                }
            }
            else {
                res.send({
                    error: true,
                    text: 'Object incorrect',
                });
            }
        }
        else {
            res.send(checkADM);
        }
    }
    async changeNameRouter(req, res) {
        const body = req.body;
        const checkADM = await treatment_1.default.CheckAdminLogin(req);
        if (checkADM.error === false) {
            if (!!body.id && body.id.length && !!body.name && body.name.length) {
                const change = await treatment_1.default.dbUser.changeTheName(body.id, body.name);
                if (typeof change === 'boolean' && change === true) {
                    res.send({
                        error: false,
                        text: 'change name successfully',
                    });
                }
                else {
                    res.send({
                        error: true,
                        text: change,
                    });
                }
            }
            else {
                res.send({
                    error: true,
                    text: 'Object incorrect',
                });
            }
        }
        else {
            res.send(checkADM);
        }
    }
    async changePasswordRouter(req, res) {
        const body = req.body;
        const checkADM = await treatment_1.default.CheckAdminLogin(req);
        if (checkADM.error === false) {
            if (!!body.id &&
                body.id.length &&
                !!body.password &&
                body.password.length) {
                const change = await treatment_1.default.dbUser.changeThePass(body.id, body.password);
                if (typeof change === 'boolean' && change === true) {
                    res.send({
                        error: false,
                        text: 'change password successfully',
                    });
                }
                else {
                    res.send({
                        error: true,
                        text: change,
                    });
                }
            }
            else {
                res.send({
                    error: true,
                    text: 'Object incorrect',
                });
            }
        }
        else {
            res.send(checkADM);
        }
    }
}
module.exports = new InicializePutUser();
//# sourceMappingURL=put.js.map