"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InicializeGet = void 0;
const treatment_1 = __importDefault(require("../../help/treatment"));
const sessions_1 = require("../../help/sessions");
const inicialize_routers_1 = require("./inicialize-routers");
class InicializeGet {
    static async getAllContacts(req, res, option) {
        var _a;
        const $_HEADERS_USER = (_a = req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.error) {
                return res.send(user);
            }
        }
        const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
        if (check) {
            const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
            if (typeof getId === 'number') {
                const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                if (client && inicialize_routers_1.InicializeRouters.inicialize) {
                    const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                    getUser.child.send({ type: 'getAllContacts' });
                    this.child.on('message', (response) => {
                        if (response.result && response.typeGet === 'getAllContacts') {
                            try {
                                return res.status(200).send(response);
                            }
                            catch (_a) { }
                        }
                    });
                }
                else {
                    return res.send({
                        error: true,
                        text: 'Waiting for connection with whatsapp',
                    });
                }
            }
        }
        else {
            return res.send({
                error: true,
                text: 'Not connected',
            });
        }
    }
    static async checkConnect(req, res, option) {
        var _a;
        const $_HEADERS_USER = (_a = req.headers) === null || _a === void 0 ? void 0 : _a.user;
        const $_GET = req.params;
        if (!!$_GET.name && $_GET.name.length) {
            if (option.authentication) {
                const user = await treatment_1.default.CheckUserLogin(req);
                if (user.error) {
                    return res.send(user);
                }
            }
            const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
            if (check) {
                const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                if (typeof getId === 'number') {
                    const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                    if (client && inicialize_routers_1.InicializeRouters.inicialize) {
                        try {
                            return res.status(200).send({
                                error: false,
                                connect: true,
                            });
                        }
                        catch (_b) { }
                    }
                    else {
                        return res.send({
                            error: true,
                            connect: false,
                        });
                    }
                }
            }
            else {
                return res.send({
                    error: true,
                    text: 'Not connected',
                });
            }
        }
        else {
            return res.send({
                error: true,
                text: 'The parameters are missing',
            });
        }
    }
    static async lastQrcode(req, res, option) {
        var _a;
        const $_HEADERS_USER = (_a = req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.error) {
                return res.send(user);
            }
        }
        const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
        if (check) {
            const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
            if (typeof getId === 'number') {
                const imgBase64 = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'base64Image', getId);
                if (imgBase64) {
                    res.send({
                        error: false,
                        base64Image: sessions_1.sessionClient.session[getId].base64Image,
                    });
                }
                else {
                    res.send({
                        error: true,
                        base64Image: '',
                    });
                }
            }
        }
        else {
            return res.send({
                error: true,
                text: 'Not connected',
            });
        }
    }
    static async screenshot(req, res, option) {
        var _a;
        const $_HEADERS_USER = (_a = req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.error) {
                return res.send(user);
            }
        }
        const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
        if (check) {
            const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
            if (typeof getId === 'number') {
                const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                if (client && inicialize_routers_1.InicializeRouters.inicialize) {
                    const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                    getUser.child.send({ type: 'screenshot' });
                    this.child.on('message', (response) => {
                        if (response.result && response.typeGet === 'screenshot') {
                            try {
                                return res.status(200).send(response);
                            }
                            catch (_a) { }
                        }
                    });
                }
                else {
                    return res.send({
                        error: true,
                        text: 'Waiting for connection with whatsapp',
                    });
                }
            }
        }
        else {
            return res.send({
                error: true,
                text: 'Not connected',
            });
        }
    }
}
exports.InicializeGet = InicializeGet;
//# sourceMappingURL=get.js.map