"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InicializePost = void 0;
const sessions_1 = require("../../help/sessions");
const treatment_1 = __importDefault(require("../../help/treatment"));
const get_1 = require("./get");
const inicialize_routers_1 = require("./inicialize-routers");
class InicializePost extends get_1.InicializeGet {
    static async checkUser(req, res) {
        const user = await treatment_1.default.CheckUserLogin(req);
        if (user.error === false) {
            res.send({
                error: false,
                text: 'Existing user',
            });
        }
        else {
            res.send(user);
        }
    }
    static async sendtext(req, res, option) {
        var _a;
        const body = req.body;
        const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.error) {
                return res.send(user);
            }
        }
        if (!!body.to && body.to.length && !!body.body && body.body.length) {
            const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
            if (check) {
                const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                if (typeof getId === 'number') {
                    const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                    if (client && inicialize_routers_1.InicializeRouters.inicialize) {
                        const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                        getUser.child.send(Object.assign({ type: 'sendText' }, body));
                        this.child.on('message', (response) => {
                            if (response.result && response.typeSend === 'sendText') {
                                try {
                                    return res.status(200).send(response);
                                }
                                catch (_a) { }
                            }
                        });
                    }
                    else {
                        return res.send({
                            error: true,
                            text: 'Waiting for connection with whatsapp',
                        });
                    }
                }
            }
            else {
                return res.send({
                    error: true,
                    text: 'Not connected',
                });
            }
        }
        else {
            return res.send({
                error: true,
                text: 'The parameters are missing',
            });
        }
    }
    static async sendFile(req, res, option) {
        var _a;
        const body = req.body;
        const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.error) {
                return res.send(user);
            }
        }
        if (!!body.to &&
            body.to.length &&
            !!body.file_path &&
            body.file_path.length &&
            !!body.file_name &&
            body.file_name.length) {
            const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
            if (check) {
                const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                if (typeof getId === 'number') {
                    const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                    if (client && inicialize_routers_1.InicializeRouters.inicialize) {
                        const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                        getUser.child.send(Object.assign({ type: 'sendFile' }, body));
                        this.child.on('message', (response) => {
                            if (response.result && response.typeSend === 'sendFile') {
                                try {
                                    return res.status(200).send(response);
                                }
                                catch (_a) { }
                            }
                        });
                    }
                    else {
                        return res.send({
                            error: true,
                            text: 'Waiting for connection with whatsapp',
                        });
                    }
                }
            }
            else {
                return res.send({
                    error: true,
                    text: 'Not connected',
                });
            }
        }
        else {
            return res.send({
                error: true,
                text: 'The parameters are missing',
            });
        }
    }
    static async sendAudio(req, res, option) {
        var _a;
        const body = req.body;
        const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.error) {
                return res.send(user);
            }
        }
        if (!!body.to && body.to.length && !!body.url_mp3 && body.url_mp3.length) {
            const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
            if (check) {
                const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                if (typeof getId === 'number') {
                    const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                    if (client && inicialize_routers_1.InicializeRouters.inicialize) {
                        const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                        getUser.child.send(Object.assign({ type: 'sendAudio' }, body));
                        this.child.on('message', (response) => {
                            if (response.result && response.typeSend === 'sendAudio') {
                                try {
                                    return res.status(200).send(response);
                                }
                                catch (_a) { }
                            }
                        });
                    }
                    else {
                        return res.send({
                            error: true,
                            text: 'Waiting for connection with whatsapp',
                        });
                    }
                }
            }
            else {
                return res.send({
                    error: true,
                    text: 'Not connected',
                });
            }
        }
        else {
            return res.send({
                error: true,
                text: 'The parameters are missing',
            });
        }
    }
    static async sendImage(req, res, option) {
        var _a;
        const body = req.body;
        const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.error) {
                return res.send(user);
            }
        }
        if (!!body.to && body.to.length && !!body.url_img && body.url_img.length) {
            const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
            if (check) {
                const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                if (typeof getId === 'number') {
                    const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                    if (client && inicialize_routers_1.InicializeRouters.inicialize) {
                        const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                        getUser.child.send(Object.assign({ type: 'sendImage' }, body));
                        this.child.on('message', (response) => {
                            if (response.result && response.typeSend === 'sendImage') {
                                try {
                                    return res.status(200).send(response);
                                }
                                catch (_a) { }
                            }
                        });
                    }
                    else {
                        return res.send({
                            error: true,
                            text: 'Waiting for connection with whatsapp',
                        });
                    }
                }
            }
            else {
                return res.send({
                    error: true,
                    text: 'Not connected',
                });
            }
        }
        else {
            return res.send({
                error: true,
                text: 'The parameters are missing',
            });
        }
    }
    static async disconnect(req, res, option) {
        var _a;
        const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.error) {
                return res.send(user);
            }
        }
        const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
        if (check) {
            const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
            if (typeof getId === 'number') {
                const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                try {
                    getUser.child.send({ type: 'disconnect' });
                }
                catch (error) {
                    console.log(error);
                    return res.send({
                        error: true,
                        text: 'Not connected',
                    });
                }
                this.child.on('message', async (response) => {
                    if (response.result && response.typeSend === 'disconnect') {
                        try {
                            await sessions_1.sessionClient.deleteSession($_HEADERS_USER);
                            return res.send(response);
                        }
                        catch (error) {
                            return res.send({
                                error: true,
                                text: "Error disconnect, can't delete the session",
                            });
                        }
                    }
                });
            }
        }
        else {
            return res.send({
                error: true,
                text: 'Not connected',
            });
        }
    }
}
exports.InicializePost = InicializePost;
//# sourceMappingURL=post.js.map