"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.startSession = void 0;
const treatment_1 = __importDefault(require("../../help/treatment"));
const sessions_1 = require("../../help/sessions");
const child_process_1 = require("child_process");
const inicialize_routers_1 = require("./inicialize-routers");
const crypto_1 = __importDefault(require("crypto"));
async function startSession(req, res, option) {
    const body = req.body;
    const reHttp = /^https?:/;
    const $_HEADERS_USER = req.headers.user;
    const $_HEADERS_PASS = req.headers.user_pass;
    if (option.authentication) {
        const user = await treatment_1.default.CheckUserLogin(req);
        if (user.error) {
            return res.send(user);
        }
    }
    if (body.url && body.url.length && !reHttp.test(body.url)) {
        return res.send({ error: true, text: 'Error http webHook' });
    }
    const session = await sessions_1.sessionClient.newSession($_HEADERS_USER);
    if (session) {
        const MergeToken = typeof $_HEADERS_USER === 'string' && typeof $_HEADERS_PASS === 'string'
            ? $_HEADERS_USER + $_HEADERS_PASS
            : '';
        const token = crypto_1.default.createHash('md5').update(MergeToken).digest('hex');
        option.session =
            typeof $_HEADERS_USER === 'string' ? $_HEADERS_USER : undefined;
        option.url = body.url;
        option.token = token;
        const spawnArgs = [
            __dirname + '../../../services/hydra.js',
            JSON.stringify(option),
        ];
        let child = (0, child_process_1.spawn)('node', spawnArgs, {
            stdio: ['inherit', 'inherit', 'inherit', 'ipc'],
        });
        new inicialize_routers_1.InicializeRouters(child, option);
        child.on('message', async (response) => {
            if (response.connect) {
                await sessions_1.sessionClient.addInfoSession(response.session, {
                    connect: response.connect,
                });
                await sessions_1.sessionClient.addInfoSession(response.session, {
                    base64Image: '',
                });
            }
            if (response.base64Image) {
                await sessions_1.sessionClient.addInfoSession(response.session, {
                    base64Image: response.base64Image,
                });
            }
            if (response.delsession) {
                await sessions_1.sessionClient.deleteSession(response.session);
            }
        });
        child.on('disconnect', (err) => {
            console.log('disconnect', err ? err : '');
        });
        child.on('error', async (err) => {
            if (err) {
                console.log('on error', err);
            }
        });
        child.on('close', async (code) => {
            console.log(`child process exited with code`, code);
        });
        child.on('uncaughtException', (err) => {
            console.log(err);
        });
        sessions_1.sessionClient.addInfoSession($_HEADERS_USER, { child: child });
        return res.send({ error: false, text: 'Wait for connection' });
    }
    else {
        const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
        const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
        if (typeof getId === 'number') {
            const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
            if (check && client) {
                return res.send({ error: false, text: 'Successfully connected!' });
            }
            else {
                return res.send({ error: false, text: 'Wait for connection' });
            }
        }
    }
}
exports.startSession = startSession;
//# sourceMappingURL=start-session.js.map