"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.postRouters = void 0;
const start_session_1 = require("../functions/start-session");
const inicialize_routers_1 = require("../functions/inicialize-routers");
const postRouters = (router, option) => {
    // Connect user
    router.post('/connect', async (req, res) => {
        await (0, start_session_1.startSession)(req, res, option);
    });
    // Check user
    router.post('/check_user', async (req, res) => {
        await inicialize_routers_1.InicializeRouters.checkUser(req, res);
    });
    // Send a text message
    router.post('/sendtext', async (req, res) => {
        await inicialize_routers_1.InicializeRouters.sendtext(req, res, option);
    });
    // Send file
    router.post('/sendFile', async (req, res) => {
        await inicialize_routers_1.InicializeRouters.sendFile(req, res, option);
    });
    // Send Voice
    router.post('/sendAudio', async (req, res) => {
        await inicialize_routers_1.InicializeRouters.sendAudio(req, res, option);
    });
    // Send image message
    router.post('/sendImage', async (req, res) => {
        await inicialize_routers_1.InicializeRouters.sendImage(req, res, option);
    });
    // Send disconnect
    router.post('/disconnect', async (req, res) => {
        await inicialize_routers_1.InicializeRouters.disconnect(req, res, option);
    });
    // Route to test webhook
    router.post('/webhooktest', async (req, res) => {
        console.log('Webhooktest Return object ', req.body);
    });
};
exports.postRouters = postRouters;
//# sourceMappingURL=post.js.map