"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const index_1 = require("../../index");
const mime_types_1 = __importDefault(require("mime-types"));
const fs_1 = __importDefault(require("fs"));
const path = __importStar(require("path"));
function sendParent(data) {
    process.send && process.send(data);
}
async function Webhook(options, info) {
    if (!!options.url && options.url.length) {
        return new Promise(async (resolve, reject) => {
            if (info) {
                Object.assign(info, { token: options.token });
                await axios_1.default
                    .post(options.url, info)
                    .then(function (response) {
                    resolve(response);
                })
                    .catch((err) => {
                    reject(err);
                });
            }
        });
    }
}
(async () => {
    const args = process.argv.slice(2);
    const options = args[0];
    const objOptions = JSON.parse(options);
    const ev = await (0, index_1.initServer)(objOptions);
    let client;
    ev.on(index_1.OnMode.interfaceChange, (change) => {
        Webhook(objOptions, change);
    });
    ev.on(index_1.OnMode.qrcode, (qrcode) => {
        Webhook(objOptions, qrcode);
        sendParent({
            base64Image: qrcode.base64Image,
            session: objOptions.session,
        });
    });
    ev.on(index_1.OnMode.newOnAck, (ack) => {
        Webhook(objOptions, ack);
    });
    ev.on(index_1.OnMode.newMessage, async (msg) => {
        if (!msg.result.isSentByMe) {
            if (msg.result.isMedia === true || msg.result.isMMS === true) {
                try {
                    const buffer = await client.decryptFile(msg.result);
                    const folder = path.join(path.resolve(process.cwd(), 'files'));
                    if (!fs_1.default.existsSync(folder)) {
                        fs_1.default.mkdirSync(folder, {
                            recursive: true,
                        });
                    }
                    fs_1.default.chmodSync(folder, '777');
                    const fileConcat = `${msg.result.id}.${mime_types_1.default.extension(msg.result.mimetype)}`;
                    fs_1.default.writeFile(folder + '/' + fileConcat, buffer, (e) => {
                        if (e) {
                            console.log(e);
                        }
                    });
                    Object.assign(msg.result, { fileUrl: fileConcat });
                }
                catch (error) {
                    console.log(error);
                }
            }
        }
        Webhook(objOptions, msg);
    });
    ev.on(index_1.OnMode.connection, async (conn) => {
        var _a;
        if (conn.erro) {
            if (conn.statusFind === 'browser' &&
                (conn.status === 'browserClosed' ||
                    conn.status === 'autoClose' ||
                    conn.status === 'noOpenWhatzapp' ||
                    conn.status === 'noOpenBrowser')) {
                sendParent({ delsession: true, session: objOptions.session });
                try {
                    if (!((_a = client === null || client === void 0 ? void 0 : client.page) === null || _a === void 0 ? void 0 : _a.isClosed())) {
                        client.page.close();
                        process.exit();
                    }
                }
                catch (_b) { }
            }
        }
        if ((conn === null || conn === void 0 ? void 0 : conn.statusFind) === 'page') {
            client = conn.page;
            conn = null;
        }
        if (conn === null || conn === void 0 ? void 0 : conn.connect) {
            client = conn.client;
            conn = { connect: true, session: objOptions.session };
            sendParent(conn);
        }
        Webhook(objOptions, conn);
    });
    process.on('message', async (response) => {
        Webhook(objOptions, response);
        if (response.type === 'sendText') {
            await client
                .sendMessage({
                to: response.to,
                body: response.body,
                options: {
                    type: 'sendText',
                },
            })
                .then((result) => {
                sendParent(Object.assign({ typeSend: 'sendText', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeSend: 'sendText', result: true }, error));
            });
        }
        if (response.type === 'sendFile') {
            await client
                .sendMessage({
                to: response.to,
                body: response.file_path,
                options: {
                    type: 'sendFile',
                    filename: response.file_name,
                },
            })
                .then((result) => {
                sendParent(Object.assign({ typeSend: 'sendFile', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeSend: 'sendFile', result: true }, error));
            });
        }
        if (response.type === 'sendAudio') {
            await client
                .sendMessage({
                to: response.to,
                body: response.url_mp3,
                options: {
                    type: 'sendAudio',
                },
            })
                .then((result) => {
                sendParent(Object.assign({ typeSend: 'sendAudio', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeSend: 'sendAudio', result: true }, error));
            });
        }
        if (response.type === 'sendImage') {
            await client
                .sendMessage({
                to: response.to,
                body: response.url_img,
                options: {
                    type: 'sendImage',
                },
            })
                .then((result) => {
                sendParent(Object.assign({ typeSend: 'sendImage', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeSend: 'sendImage', result: true }, error));
            });
        }
        if (response.type === 'getAllContacts') {
            await client
                .getAllContacts()
                .then((result) => {
                sendParent(Object.assign({ typeGet: 'getAllContacts', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeGet: 'getAllContacts', result: true }, error));
            });
        }
        if (response.type === 'screenshot') {
            await client
                .screenshot()
                .then((result) => {
                sendParent(Object.assign({ typeGet: 'screenshot', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeGet: 'screenshot', result: true }, error));
            });
        }
        if (response.type === 'disconnect') {
            try {
                client.close();
                sendParent({ typeSend: 'disconnect', result: true });
                process.exit();
            }
            catch (e) {
                console.log(e);
                sendParent({ typeSend: 'disconnect', result: true });
                process.exit();
            }
        }
    });
})();
//# sourceMappingURL=hydra.js.map